# MKP injection delay optimiser 

This repository contains the environment to optimise the injection kicker magnet (MKP) time delays for the Super Proton Synchrotron (SPS) injection system. In the ideal case, the injected beam time stamp is placed on the flat top where there is full deflection from the injection kicker, and the already circulating beam should arrive before when there is no field. The separation in time between the injected and circulating beam is called *batch spacing*. The typical waveform of an injection kicker can be seen below.

![mkp_waveform_illustrated.png](./mkp_waveform_illustrated.png)

However, the waveforms of the MKP magnets are not perfect boxcar functions. In real operations, there are ripples at the flat top. With the tight batch spacing required by the LHC beams - often 200-500 ns - one must compromise between giving full deflection to the injected beam, and as little deflection as possible to the circulating beam. The main objective is to minimize the squared sum of the injection oscillation amplitude of the circulating and injected beam, by finding the ideal time delays for the MKP timings in nanoseconds. In total, there are eight individual time shifts and one general time shift for the MKP magnet modules. My Master's thesis on the subject can be found on [CDS](https://cds.cern.ch/record/2813209), which narrates the technical set-up more in detail. 

The main environment `mkpdelays_env.py` used for the optimisation is based on the GYM environment API. The environment follows the standards of the [optimisation GUI](https://gitlab.cern.ch/be-op-ml-optimization/acc-app-optimisation) already used for many optimisers in the CERN Control Centre (CCC). The main methods are:
- `__init()__` is the constructor, where we select the batch spacing, which MKP delays to shift, the time delay limit, and the beam type. We also define whether to use historical waveform data to simulate on (FakeMKPDelays) or extracting the ones from the real accelerator (RealMKPDelays). 
- `reset()` is called at the beginning of an episode, returning the initial observation of the state 
- `render()` visualizes how the injection time stamps are changed in action.
- `step(action)` takes an action with the environment, returns the next observation, the immediate reward, and a boolean whether the episode has finished or not. 

The `step()` method calls another method `_take_action()`, which checks whether the action is within the specified bounds and in turn calls the method `_get_reward()`, which retrieves the injection oscillation amplitude from a beam position monitor (BPM) in the SPS. The input action is always normalized to be in $`[-1, 1]`$. This BPM data is either simulated from beam dynamics simulations in MAD-X, or retrieved from the actual BPMs in the SPS, for which we use two different subclasses:
- `fake_mkp_delays.py` simulates injection oscillation amplitudes at BPM positions from MAD-X for a given time shift vector $`d\tau = `$ ` [MKP1_individual_shift, ..., MKP8_individual_shift, general_time_shift]` through its method `get_positions`.
- `real_mkp_delays.py` initializes the parameter subscription in its constructor to constantly monitor the beam position data at the BPMs at every injection. Its `callback` method handles these subscriptions and the method `_wait_good_cycle_and_get_bpm_pos` ensures that the right machine cycle is running and that we record the BPM position at injection only. Also the beam intensity from the device class `BCTDC` is checked to be high enough. The method `get_positions` takes $`d\tau`$ as input and finally uses these other methods to return the BPM positions (from the `BPMLHC` from the repository `cern-general-devices`). The device `mkp_delays.py` from `cern-general-devices` is used to communicate with the accelerator using Java API for Parameter Control (JAPC). In our environment, we get and set parameters for the MKPs in via the Python library [PyJapc](https://gitlab.cern.ch/scripting-tools/pyjapc). 

The wrapper function is located in `mkpenv_single_objective_tester.py`, which initializes the environment in `mkpdelays_env.py` and optimises the MKP time delays to find the minimal injection oscillations, using the BOBYQA algorithm, where the objective function value and actions are monitored during the optimisation process. The wrapper `mkpenv_single_objective_tester_bayesian.py` analogously optimises the delays, but with Bayesian optimisation. The `mkp_monitor_script_and_callback.py` is a monitoring script to observe real injection oscillations at all three BPMs in the SPS over many turns, depending on how the MKP waveforms change. If the delays are changed unvoluntarily, the scripts `reset_initial_x0.py` and `reset_latest_optimised_x0.py` can be used to reset the delays to initial values, or from the latest optimisation. The repository also contains a folder with BPM data and a BPM data extraction script, and a separate folder for JAPC tests.   

An example of the effect of the optimiser for LHCINDIV beam types of 225 ns and 200 ns batch spacing can be seen in the figure below, where the oscillation amplitude decreased by up to 70% after the optimiser was implemented.

![injection_oscillations.png](./injection_oscillations.png)
